/* sortedset.c generated by valac, the Vala compiler
 * generated from sortedset.vala, do not modify */

/* sortedset.vala
 *
 * Copyright (C) 2009  Didier Villevalois, Maciej Piechotka
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.

 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 *
 * Author:
 * 	Maciej Piechotka <uzytkownik2@gmail.com>
 */

#include <glib.h>
#include <glib-object.h>


#define GEE_TYPE_ITERABLE (gee_iterable_get_type ())
#define GEE_ITERABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEE_TYPE_ITERABLE, GeeIterable))
#define GEE_IS_ITERABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEE_TYPE_ITERABLE))
#define GEE_ITERABLE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), GEE_TYPE_ITERABLE, GeeIterableIface))

typedef struct _GeeIterable GeeIterable;
typedef struct _GeeIterableIface GeeIterableIface;

#define GEE_TYPE_ITERATOR (gee_iterator_get_type ())
#define GEE_ITERATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEE_TYPE_ITERATOR, GeeIterator))
#define GEE_IS_ITERATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEE_TYPE_ITERATOR))
#define GEE_ITERATOR_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), GEE_TYPE_ITERATOR, GeeIteratorIface))

typedef struct _GeeIterator GeeIterator;
typedef struct _GeeIteratorIface GeeIteratorIface;

#define GEE_TYPE_COLLECTION (gee_collection_get_type ())
#define GEE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEE_TYPE_COLLECTION, GeeCollection))
#define GEE_IS_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEE_TYPE_COLLECTION))
#define GEE_COLLECTION_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), GEE_TYPE_COLLECTION, GeeCollectionIface))

typedef struct _GeeCollection GeeCollection;
typedef struct _GeeCollectionIface GeeCollectionIface;

#define GEE_TYPE_SET (gee_set_get_type ())
#define GEE_SET(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEE_TYPE_SET, GeeSet))
#define GEE_IS_SET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEE_TYPE_SET))
#define GEE_SET_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), GEE_TYPE_SET, GeeSetIface))

typedef struct _GeeSet GeeSet;
typedef struct _GeeSetIface GeeSetIface;

#define GEE_TYPE_SORTED_SET (gee_sorted_set_get_type ())
#define GEE_SORTED_SET(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEE_TYPE_SORTED_SET, GeeSortedSet))
#define GEE_IS_SORTED_SET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEE_TYPE_SORTED_SET))
#define GEE_SORTED_SET_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), GEE_TYPE_SORTED_SET, GeeSortedSetIface))

typedef struct _GeeSortedSet GeeSortedSet;
typedef struct _GeeSortedSetIface GeeSortedSetIface;

#define GEE_TYPE_BIDIR_ITERATOR (gee_bidir_iterator_get_type ())
#define GEE_BIDIR_ITERATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEE_TYPE_BIDIR_ITERATOR, GeeBidirIterator))
#define GEE_IS_BIDIR_ITERATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEE_TYPE_BIDIR_ITERATOR))
#define GEE_BIDIR_ITERATOR_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), GEE_TYPE_BIDIR_ITERATOR, GeeBidirIteratorIface))

typedef struct _GeeBidirIterator GeeBidirIterator;
typedef struct _GeeBidirIteratorIface GeeBidirIteratorIface;

struct _GeeIteratorIface {
	GTypeInterface parent_iface;
	gboolean (*next) (GeeIterator* self);
	gboolean (*has_next) (GeeIterator* self);
	gboolean (*first) (GeeIterator* self);
	gpointer (*get) (GeeIterator* self);
	void (*remove) (GeeIterator* self);
};

struct _GeeIterableIface {
	GTypeInterface parent_iface;
	GeeIterator* (*iterator) (GeeIterable* self);
	GType (*get_element_type) (GeeIterable* self);
};

struct _GeeCollectionIface {
	GTypeInterface parent_iface;
	gboolean (*contains) (GeeCollection* self, gconstpointer item);
	gboolean (*add) (GeeCollection* self, gconstpointer item);
	gboolean (*remove) (GeeCollection* self, gconstpointer item);
	void (*clear) (GeeCollection* self);
	gboolean (*add_all) (GeeCollection* self, GeeCollection* collection);
	gboolean (*contains_all) (GeeCollection* self, GeeCollection* collection);
	gboolean (*remove_all) (GeeCollection* self, GeeCollection* collection);
	gboolean (*retain_all) (GeeCollection* self, GeeCollection* collection);
	gpointer* (*to_array) (GeeCollection* self, int* result_length1);
	gint (*get_size) (GeeCollection* self);
	gboolean (*get_is_empty) (GeeCollection* self);
	GeeCollection* (*get_read_only_view) (GeeCollection* self);
};

struct _GeeSetIface {
	GTypeInterface parent_iface;
	GeeSet* (*get_read_only_view) (GeeSet* self);
};

struct _GeeBidirIteratorIface {
	GTypeInterface parent_iface;
	gboolean (*previous) (GeeBidirIterator* self);
	gboolean (*has_previous) (GeeBidirIterator* self);
	gboolean (*last) (GeeBidirIterator* self);
};

struct _GeeSortedSetIface {
	GTypeInterface parent_iface;
	gpointer (*first) (GeeSortedSet* self);
	gpointer (*last) (GeeSortedSet* self);
	GeeBidirIterator* (*bidir_iterator) (GeeSortedSet* self);
	GeeBidirIterator* (*iterator_at) (GeeSortedSet* self, gconstpointer element);
	gpointer (*lower) (GeeSortedSet* self, gconstpointer element);
	gpointer (*higher) (GeeSortedSet* self, gconstpointer element);
	gpointer (*floor) (GeeSortedSet* self, gconstpointer element);
	gpointer (*ceil) (GeeSortedSet* self, gconstpointer element);
	GeeSortedSet* (*head_set) (GeeSortedSet* self, gconstpointer before);
	GeeSortedSet* (*tail_set) (GeeSortedSet* self, gconstpointer after);
	GeeSortedSet* (*sub_set) (GeeSortedSet* self, gconstpointer from, gconstpointer to);
};



GType gee_iterator_get_type (void) G_GNUC_CONST;
GType gee_iterable_get_type (void) G_GNUC_CONST;
GType gee_collection_get_type (void) G_GNUC_CONST;
GType gee_set_get_type (void) G_GNUC_CONST;
GType gee_bidir_iterator_get_type (void) G_GNUC_CONST;
GType gee_sorted_set_get_type (void) G_GNUC_CONST;
gpointer gee_sorted_set_first (GeeSortedSet* self);
gpointer gee_sorted_set_last (GeeSortedSet* self);
GeeBidirIterator* gee_sorted_set_bidir_iterator (GeeSortedSet* self);
GeeBidirIterator* gee_sorted_set_iterator_at (GeeSortedSet* self, gconstpointer element);
gpointer gee_sorted_set_lower (GeeSortedSet* self, gconstpointer element);
gpointer gee_sorted_set_higher (GeeSortedSet* self, gconstpointer element);
gpointer gee_sorted_set_floor (GeeSortedSet* self, gconstpointer element);
gpointer gee_sorted_set_ceil (GeeSortedSet* self, gconstpointer element);
GeeSortedSet* gee_sorted_set_head_set (GeeSortedSet* self, gconstpointer before);
GeeSortedSet* gee_sorted_set_tail_set (GeeSortedSet* self, gconstpointer after);
GeeSortedSet* gee_sorted_set_sub_set (GeeSortedSet* self, gconstpointer from, gconstpointer to);



/**
 * Returns the first element of the sorted set. Set must not be empty.
 *
 * @return the first element in the sorted set
 */
#line 32 "sortedset.vala"
gpointer gee_sorted_set_first (GeeSortedSet* self) {
#line 32 "sortedset.vala"
	return GEE_SORTED_SET_GET_INTERFACE (self)->first (self);
#line 168 "sortedset.c"
}


/**
 * Returns the last element of the sorted set. Set must not be empty.
 *
 * @return the last element in the sorted set
 */
#line 39 "sortedset.vala"
gpointer gee_sorted_set_last (GeeSortedSet* self) {
#line 39 "sortedset.vala"
	return GEE_SORTED_SET_GET_INTERFACE (self)->last (self);
#line 181 "sortedset.c"
}


/**
 * Returns a {@link BidirIterator} that can be used for bi-directional
 * iteration over this sorted set.
 *
 * @return a {@link BidirIterator} over this sorted set
 */
#line 47 "sortedset.vala"
GeeBidirIterator* gee_sorted_set_bidir_iterator (GeeSortedSet* self) {
#line 47 "sortedset.vala"
	return GEE_SORTED_SET_GET_INTERFACE (self)->bidir_iterator (self);
#line 195 "sortedset.c"
}


/**
 * Returns a {@link BidirIterator} initialy pointed at the specified
 * element.
 *
 * @param element the element to point the iterator at
 *
 * @return        a {@link BidirIterator} over this sorted set, or null if
 *                the specified element is not in this set
 */
#line 58 "sortedset.vala"
GeeBidirIterator* gee_sorted_set_iterator_at (GeeSortedSet* self, gconstpointer element) {
#line 58 "sortedset.vala"
	return GEE_SORTED_SET_GET_INTERFACE (self)->iterator_at (self, element);
#line 212 "sortedset.c"
}


/**
 * Returns the element which is strictly lower than the specified element.
 *
 * @param element the element which you want the lower element for
 *
 * @return        the corresponding element
 */
#line 67 "sortedset.vala"
gpointer gee_sorted_set_lower (GeeSortedSet* self, gconstpointer element) {
#line 67 "sortedset.vala"
	return GEE_SORTED_SET_GET_INTERFACE (self)->lower (self, element);
#line 227 "sortedset.c"
}


/**
 * Returns the element which is strictly higher than the specified element.
 *
 * @param element the element which you want the strictly higher element
 *                for
 *
 * @return        the corresponding element
 */
#line 77 "sortedset.vala"
gpointer gee_sorted_set_higher (GeeSortedSet* self, gconstpointer element) {
#line 77 "sortedset.vala"
	return GEE_SORTED_SET_GET_INTERFACE (self)->higher (self, element);
#line 243 "sortedset.c"
}


/**
 * Returns the element which is lower or equal then the specified element.
 *
 * @param element the element which you want the lower or equal element for
 *
 * @return        the corresponding element
 */
#line 86 "sortedset.vala"
gpointer gee_sorted_set_floor (GeeSortedSet* self, gconstpointer element) {
#line 86 "sortedset.vala"
	return GEE_SORTED_SET_GET_INTERFACE (self)->floor (self, element);
#line 258 "sortedset.c"
}


/**
 * Returns the element which is higher or equal then the specified element.
 *
 * @param element the element which you want the higher or equal element
 *                for
 *
 * @return        the corresponding element
 */
#line 96 "sortedset.vala"
gpointer gee_sorted_set_ceil (GeeSortedSet* self, gconstpointer element) {
#line 96 "sortedset.vala"
	return GEE_SORTED_SET_GET_INTERFACE (self)->ceil (self, element);
#line 274 "sortedset.c"
}


/**
 * Returns the sub-set of this sorted set containing elements strictly
 * lower than the specified element.
 *
 * @param from the lower inclusive bound for the sub-set
 *
 * @return     the corresponding sub-set of this sorted set
 */
#line 106 "sortedset.vala"
GeeSortedSet* gee_sorted_set_head_set (GeeSortedSet* self, gconstpointer before) {
#line 106 "sortedset.vala"
	return GEE_SORTED_SET_GET_INTERFACE (self)->head_set (self, before);
#line 290 "sortedset.c"
}


/**
 * Returns the sub-set of this sorted set containing elements equal or
 * higher than the specified element.
 *
 * @param to the higher exclusive bound for the sub-set
 *
 * @return   the corresponding sub-set of this sorted set
 */
#line 116 "sortedset.vala"
GeeSortedSet* gee_sorted_set_tail_set (GeeSortedSet* self, gconstpointer after) {
#line 116 "sortedset.vala"
	return GEE_SORTED_SET_GET_INTERFACE (self)->tail_set (self, after);
#line 306 "sortedset.c"
}


/**
 * Returns the right-open sub-set of this sorted set, thus containing
 * elements equal or higher than the specified `from` element, and stricly
 * lower than the specified `to` element.
 *
 * @param from the lower inclusive bound for the sub-set
 * @param to   the higher exclusive bound for the sub-set
 *
 * @return     the corresponding sub-set of this sorted set
 */
#line 128 "sortedset.vala"
GeeSortedSet* gee_sorted_set_sub_set (GeeSortedSet* self, gconstpointer from, gconstpointer to) {
#line 128 "sortedset.vala"
	return GEE_SORTED_SET_GET_INTERFACE (self)->sub_set (self, from, to);
#line 324 "sortedset.c"
}


static void gee_sorted_set_base_init (GeeSortedSetIface * iface) {
	static gboolean initialized = FALSE;
	if (!initialized) {
		initialized = TRUE;
	}
}


/**
 * A sorted set, which you can navigate over and get sub-sets of.
 */
GType gee_sorted_set_get_type (void) {
	static volatile gsize gee_sorted_set_type_id__volatile = 0;
	if (g_once_init_enter (&gee_sorted_set_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GeeSortedSetIface), (GBaseInitFunc) gee_sorted_set_base_init, (GBaseFinalizeFunc) NULL, (GClassInitFunc) NULL, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType gee_sorted_set_type_id;
		gee_sorted_set_type_id = g_type_register_static (G_TYPE_INTERFACE, "GeeSortedSet", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (gee_sorted_set_type_id, GEE_TYPE_SET);
		g_once_init_leave (&gee_sorted_set_type_id__volatile, gee_sorted_set_type_id);
	}
	return gee_sorted_set_type_id__volatile;
}




